/* Generated by wayland-scanner 1.19.0 */

#ifndef SCREENCOPY_UNSTABLE_V1_CLIENT_PROTOCOL_H
#define SCREENCOPY_UNSTABLE_V1_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_screencopy_unstable_v1 The screencopy_unstable_v1 protocol
 * screen content capturing on client buffers
 *
 * @section page_desc_screencopy_unstable_v1 Description
 *
 * This protocol allows clients to ask the compositor to copy part of the
 * screen content to a client buffer.
 *
 * Warning! The protocol described in this file is experimental and
 * backward incompatible changes may be made. Backward compatible changes
 * may be added together with the corresponding interface version bump.
 * Backward incompatible changes are done by bumping the version number in
 * the protocol and interface names and resetting the interface version.
 * Once the protocol is to be declared stable, the 'z' prefix and the
 * version number in the protocol and interface names are removed and the
 * interface version number is reset.
 *
 * @section page_ifaces_screencopy_unstable_v1 Interfaces
 * - @subpage page_iface_zext_screencopy_manager_v1 - manager to inform clients and begin capturing
 * - @subpage page_iface_zext_screencopy_surface_v1 - a frame ready for copy
 * @section page_copyright_screencopy_unstable_v1 Copyright
 * <pre>
 *
 * Copyright © 2021 Andri Yngvason
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 * </pre>
 */
struct wl_buffer;
struct wl_output;
struct zext_screencopy_manager_v1;
struct zext_screencopy_surface_v1;

#ifndef ZEXT_SCREENCOPY_MANAGER_V1_INTERFACE
#define ZEXT_SCREENCOPY_MANAGER_V1_INTERFACE
/**
 * @page page_iface_zext_screencopy_manager_v1 zext_screencopy_manager_v1
 * @section page_iface_zext_screencopy_manager_v1_desc Description
 *
 * This object is a manager which offers requests to start capturing from a
 * source.
 * @section page_iface_zext_screencopy_manager_v1_api API
 * See @ref iface_zext_screencopy_manager_v1.
 */
/**
 * @defgroup iface_zext_screencopy_manager_v1 The zext_screencopy_manager_v1 interface
 *
 * This object is a manager which offers requests to start capturing from a
 * source.
 */
extern const struct wl_interface zext_screencopy_manager_v1_interface;
#endif
#ifndef ZEXT_SCREENCOPY_SURFACE_V1_INTERFACE
#define ZEXT_SCREENCOPY_SURFACE_V1_INTERFACE
/**
 * @page page_iface_zext_screencopy_surface_v1 zext_screencopy_surface_v1
 * @section page_iface_zext_screencopy_surface_v1_desc Description
 *
 * This object represents a surface that's being captured.
 *
 * After a screencopy surface is created, buffer_info events will be emitted
 * from the compositor to tell the client which buffer types and formats are
 * supported for reading from the surface.
 *
 * When the client knows all the buffer attributes, it can create a buffer,
 * attach it to the screencopy surface using the "attach_buffer" request,
 * set the buffer damage using the "damage_buffer" request and then call
 * the "commit" request.
 *
 * After "commit" has been called, the next time that a buffer is committed
 * by the compositor, the contents of that buffer will be copied to the one
 * committed to the screencopy surface. A series of events will be generated,
 * ending with the "ready" event, which means that the buffer is ready to be
 * used and a buffer may be committed to the surface again.
 *
 * The "failed" event may be sent at any time. When this happens, the client
 * must destroy the surface. Depending on the failure reason, the client can
 * create a new surface to replace it.
 * @section page_iface_zext_screencopy_surface_v1_api API
 * See @ref iface_zext_screencopy_surface_v1.
 */
/**
 * @defgroup iface_zext_screencopy_surface_v1 The zext_screencopy_surface_v1 interface
 *
 * This object represents a surface that's being captured.
 *
 * After a screencopy surface is created, buffer_info events will be emitted
 * from the compositor to tell the client which buffer types and formats are
 * supported for reading from the surface.
 *
 * When the client knows all the buffer attributes, it can create a buffer,
 * attach it to the screencopy surface using the "attach_buffer" request,
 * set the buffer damage using the "damage_buffer" request and then call
 * the "commit" request.
 *
 * After "commit" has been called, the next time that a buffer is committed
 * by the compositor, the contents of that buffer will be copied to the one
 * committed to the screencopy surface. A series of events will be generated,
 * ending with the "ready" event, which means that the buffer is ready to be
 * used and a buffer may be committed to the surface again.
 *
 * The "failed" event may be sent at any time. When this happens, the client
 * must destroy the surface. Depending on the failure reason, the client can
 * create a new surface to replace it.
 */
extern const struct wl_interface zext_screencopy_surface_v1_interface;
#endif

#define ZEXT_SCREENCOPY_MANAGER_V1_CAPTURE_OUTPUT 0
#define ZEXT_SCREENCOPY_MANAGER_V1_CAPTURE_OUTPUT_CURSOR 1


/**
 * @ingroup iface_zext_screencopy_manager_v1
 */
#define ZEXT_SCREENCOPY_MANAGER_V1_CAPTURE_OUTPUT_SINCE_VERSION 1
/**
 * @ingroup iface_zext_screencopy_manager_v1
 */
#define ZEXT_SCREENCOPY_MANAGER_V1_CAPTURE_OUTPUT_CURSOR_SINCE_VERSION 1

/** @ingroup iface_zext_screencopy_manager_v1 */
static inline void
zext_screencopy_manager_v1_set_user_data(struct zext_screencopy_manager_v1 *zext_screencopy_manager_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zext_screencopy_manager_v1, user_data);
}

/** @ingroup iface_zext_screencopy_manager_v1 */
static inline void *
zext_screencopy_manager_v1_get_user_data(struct zext_screencopy_manager_v1 *zext_screencopy_manager_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zext_screencopy_manager_v1);
}

static inline uint32_t
zext_screencopy_manager_v1_get_version(struct zext_screencopy_manager_v1 *zext_screencopy_manager_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) zext_screencopy_manager_v1);
}

/** @ingroup iface_zext_screencopy_manager_v1 */
static inline void
zext_screencopy_manager_v1_destroy(struct zext_screencopy_manager_v1 *zext_screencopy_manager_v1)
{
	wl_proxy_destroy((struct wl_proxy *) zext_screencopy_manager_v1);
}

/**
 * @ingroup iface_zext_screencopy_manager_v1
 *
 * Create a capturing surface for an output
 */
static inline struct zext_screencopy_surface_v1 *
zext_screencopy_manager_v1_capture_output(struct zext_screencopy_manager_v1 *zext_screencopy_manager_v1, struct wl_output *output)
{
	struct wl_proxy *surface;

	surface = wl_proxy_marshal_constructor((struct wl_proxy *) zext_screencopy_manager_v1,
			 ZEXT_SCREENCOPY_MANAGER_V1_CAPTURE_OUTPUT, &zext_screencopy_surface_v1_interface, NULL, output);

	return (struct zext_screencopy_surface_v1 *) surface;
}

/**
 * @ingroup iface_zext_screencopy_manager_v1
 *
 * Create a capturing surface for an output's cursor
 */
static inline struct zext_screencopy_surface_v1 *
zext_screencopy_manager_v1_capture_output_cursor(struct zext_screencopy_manager_v1 *zext_screencopy_manager_v1, struct wl_output *output)
{
	struct wl_proxy *surface;

	surface = wl_proxy_marshal_constructor((struct wl_proxy *) zext_screencopy_manager_v1,
			 ZEXT_SCREENCOPY_MANAGER_V1_CAPTURE_OUTPUT_CURSOR, &zext_screencopy_surface_v1_interface, NULL, output);

	return (struct zext_screencopy_surface_v1 *) surface;
}

#ifndef ZEXT_SCREENCOPY_SURFACE_V1_FAILURE_REASON_ENUM
#define ZEXT_SCREENCOPY_SURFACE_V1_FAILURE_REASON_ENUM
enum zext_screencopy_surface_v1_failure_reason {
	ZEXT_SCREENCOPY_SURFACE_V1_FAILURE_REASON_UNSPEC = 0,
	ZEXT_SCREENCOPY_SURFACE_V1_FAILURE_REASON_INVALID_BUFFER = 1,
	ZEXT_SCREENCOPY_SURFACE_V1_FAILURE_REASON_OUTPUT_MISSING = 2,
	ZEXT_SCREENCOPY_SURFACE_V1_FAILURE_REASON_OUTPUT_DISABLED = 3,
	ZEXT_SCREENCOPY_SURFACE_V1_FAILURE_REASON_CURSOR_MISSING = 4,
};
#endif /* ZEXT_SCREENCOPY_SURFACE_V1_FAILURE_REASON_ENUM */

#ifndef ZEXT_SCREENCOPY_SURFACE_V1_OPTIONS_ENUM
#define ZEXT_SCREENCOPY_SURFACE_V1_OPTIONS_ENUM
enum zext_screencopy_surface_v1_options {
	ZEXT_SCREENCOPY_SURFACE_V1_OPTIONS_NONE = 0,
	ZEXT_SCREENCOPY_SURFACE_V1_OPTIONS_WAIT_FOR_DAMAGE = 1,
	ZEXT_SCREENCOPY_SURFACE_V1_OPTIONS_SCHEDULE_FRAME = 2,
};
#endif /* ZEXT_SCREENCOPY_SURFACE_V1_OPTIONS_ENUM */

#ifndef ZEXT_SCREENCOPY_SURFACE_V1_BUFFER_TYPE_ENUM
#define ZEXT_SCREENCOPY_SURFACE_V1_BUFFER_TYPE_ENUM
enum zext_screencopy_surface_v1_buffer_type {
	ZEXT_SCREENCOPY_SURFACE_V1_BUFFER_TYPE_NONE = 0,
	ZEXT_SCREENCOPY_SURFACE_V1_BUFFER_TYPE_WL_SHM = 1,
	ZEXT_SCREENCOPY_SURFACE_V1_BUFFER_TYPE_DMABUF = 2,
};
#endif /* ZEXT_SCREENCOPY_SURFACE_V1_BUFFER_TYPE_ENUM */

/**
 * @ingroup iface_zext_screencopy_surface_v1
 * @struct zext_screencopy_surface_v1_listener
 */
struct zext_screencopy_surface_v1_listener {
	/**
	 * buffer information
	 *
	 * Provides information about buffer parameters that need to be
	 * used for this surface. This event is sent for every supported
	 * buffer type after the surface is created. After all supported
	 * buffers have been enumerated, an event with type = none is sent.
	 * All other parameters should be set to 0.
	 *
	 * The stride parameter is invalid for dmabuf and may be set to 0.
	 * @param type buffer type
	 * @param format buffer drm format
	 * @param width buffer width
	 * @param height buffer height
	 * @param stride buffer stride
	 */
	void (*buffer_info)(void *data,
			    struct zext_screencopy_surface_v1 *zext_screencopy_surface_v1,
			    uint32_t type,
			    uint32_t format,
			    uint32_t width,
			    uint32_t height,
			    uint32_t stride);
	/**
	 * carries the output transform
	 *
	 * This event is sent before the ready event and holds the output
	 * transform of the source buffer.
	 */
	void (*transform)(void *data,
			  struct zext_screencopy_surface_v1 *zext_screencopy_surface_v1,
			  int32_t transform);
	/**
	 * carries the coordinates of the damaged region
	 *
	 * This event is sent before the ready event. It may be generated
	 * multiple times for each commit.
	 *
	 * The arguments describe a box around an area that has changed
	 * since the last ready event.
	 * @param x damaged x coordinates
	 * @param y damaged y coordinates
	 * @param width current width
	 * @param height current height
	 */
	void (*damage)(void *data,
		       struct zext_screencopy_surface_v1 *zext_screencopy_surface_v1,
		       uint32_t x,
		       uint32_t y,
		       uint32_t width,
		       uint32_t height);
	/**
	 * cursor specific information
	 *
	 * This event is only relevant when a cursor is being captured.
	 * It may be generated at any time, but it should at least be
	 * generated once before the first ready event of the surface.
	 * @param position_x position x coordinates
	 * @param position_y position y coordinates
	 * @param hotspot_x hotspot x coordinates
	 * @param hotspot_y hotspot y coordinates
	 */
	void (*cursor_info)(void *data,
			    struct zext_screencopy_surface_v1 *zext_screencopy_surface_v1,
			    int32_t position_x,
			    int32_t position_y,
			    int32_t hotspot_x,
			    int32_t hotspot_y);
	/**
	 * commit failed
	 *
	 * This event indicates that the attempted frame copy has failed.
	 *
	 * After receiving this event, the client should destroy the
	 * object.
	 */
	void (*failed)(void *data,
		       struct zext_screencopy_surface_v1 *zext_screencopy_surface_v1,
		       uint32_t reason);
	/**
	 * indicates the presentation time of the frame
	 *
	 * This event indicates the presentation time of the frame when
	 * applicable.
	 *
	 * The timestamp is expressed as tv_sec_hi, tv_sec_lo, tv_nsec
	 * triples, each component being an unsigned 32-bit value. Whole
	 * seconds are in tv_sec which is a 64-bit value combined from
	 * tv_sec_hi and tv_sec_lo, and the additional fractional part in
	 * tv_nsec as nanoseconds. Hence, for valid timestamps tv_nsec must
	 * be in [0, 999999999]. The seconds part may have an arbitrary
	 * offset at start.
	 * @param tv_sec_hi high 32 bits of the seconds part of the timestamp
	 * @param tv_sec_lo low 32 bits of the seconds part of the timestamp
	 * @param tv_nsec nanoseconds part of the timestamp
	 */
	void (*presentation_time)(void *data,
				  struct zext_screencopy_surface_v1 *zext_screencopy_surface_v1,
				  uint32_t tv_sec_hi,
				  uint32_t tv_sec_lo,
				  uint32_t tv_nsec);
	/**
	 * indicates frame is available for reading
	 *
	 * Called as soon as the frame is copied, indicating it is
	 * available for reading.
	 */
	void (*ready)(void *data,
		      struct zext_screencopy_surface_v1 *zext_screencopy_surface_v1);
};

/**
 * @ingroup iface_zext_screencopy_surface_v1
 */
static inline int
zext_screencopy_surface_v1_add_listener(struct zext_screencopy_surface_v1 *zext_screencopy_surface_v1,
					const struct zext_screencopy_surface_v1_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) zext_screencopy_surface_v1,
				     (void (**)(void)) listener, data);
}

#define ZEXT_SCREENCOPY_SURFACE_V1_ATTACH_BUFFER 0
#define ZEXT_SCREENCOPY_SURFACE_V1_DAMAGE_BUFFER 1
#define ZEXT_SCREENCOPY_SURFACE_V1_COMMIT 2
#define ZEXT_SCREENCOPY_SURFACE_V1_DESTROY 3

/**
 * @ingroup iface_zext_screencopy_surface_v1
 */
#define ZEXT_SCREENCOPY_SURFACE_V1_BUFFER_INFO_SINCE_VERSION 1
/**
 * @ingroup iface_zext_screencopy_surface_v1
 */
#define ZEXT_SCREENCOPY_SURFACE_V1_TRANSFORM_SINCE_VERSION 1
/**
 * @ingroup iface_zext_screencopy_surface_v1
 */
#define ZEXT_SCREENCOPY_SURFACE_V1_DAMAGE_SINCE_VERSION 1
/**
 * @ingroup iface_zext_screencopy_surface_v1
 */
#define ZEXT_SCREENCOPY_SURFACE_V1_CURSOR_INFO_SINCE_VERSION 1
/**
 * @ingroup iface_zext_screencopy_surface_v1
 */
#define ZEXT_SCREENCOPY_SURFACE_V1_FAILED_SINCE_VERSION 1
/**
 * @ingroup iface_zext_screencopy_surface_v1
 */
#define ZEXT_SCREENCOPY_SURFACE_V1_PRESENTATION_TIME_SINCE_VERSION 1
/**
 * @ingroup iface_zext_screencopy_surface_v1
 */
#define ZEXT_SCREENCOPY_SURFACE_V1_READY_SINCE_VERSION 1

/**
 * @ingroup iface_zext_screencopy_surface_v1
 */
#define ZEXT_SCREENCOPY_SURFACE_V1_ATTACH_BUFFER_SINCE_VERSION 1
/**
 * @ingroup iface_zext_screencopy_surface_v1
 */
#define ZEXT_SCREENCOPY_SURFACE_V1_DAMAGE_BUFFER_SINCE_VERSION 1
/**
 * @ingroup iface_zext_screencopy_surface_v1
 */
#define ZEXT_SCREENCOPY_SURFACE_V1_COMMIT_SINCE_VERSION 1
/**
 * @ingroup iface_zext_screencopy_surface_v1
 */
#define ZEXT_SCREENCOPY_SURFACE_V1_DESTROY_SINCE_VERSION 1

/** @ingroup iface_zext_screencopy_surface_v1 */
static inline void
zext_screencopy_surface_v1_set_user_data(struct zext_screencopy_surface_v1 *zext_screencopy_surface_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zext_screencopy_surface_v1, user_data);
}

/** @ingroup iface_zext_screencopy_surface_v1 */
static inline void *
zext_screencopy_surface_v1_get_user_data(struct zext_screencopy_surface_v1 *zext_screencopy_surface_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zext_screencopy_surface_v1);
}

static inline uint32_t
zext_screencopy_surface_v1_get_version(struct zext_screencopy_surface_v1 *zext_screencopy_surface_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) zext_screencopy_surface_v1);
}

/**
 * @ingroup iface_zext_screencopy_surface_v1
 *
 * Attach a buffer to the surface.
 */
static inline void
zext_screencopy_surface_v1_attach_buffer(struct zext_screencopy_surface_v1 *zext_screencopy_surface_v1, struct wl_buffer *buffer)
{
	wl_proxy_marshal((struct wl_proxy *) zext_screencopy_surface_v1,
			 ZEXT_SCREENCOPY_SURFACE_V1_ATTACH_BUFFER, buffer);
}

/**
 * @ingroup iface_zext_screencopy_surface_v1
 *
 * Apply damage to the buffer which is to be committed next.
 *
 * This is for optimisation purposes. The compositor may use this
 * information to reduce copying.
 *
 * The client must submit damage if it's using multiple buffers. Otherwise,
 * the server might not copy into damaged regions of the buffer.
 */
static inline void
zext_screencopy_surface_v1_damage_buffer(struct zext_screencopy_surface_v1 *zext_screencopy_surface_v1, uint32_t x, uint32_t y, uint32_t width, uint32_t height)
{
	wl_proxy_marshal((struct wl_proxy *) zext_screencopy_surface_v1,
			 ZEXT_SCREENCOPY_SURFACE_V1_DAMAGE_BUFFER, x, y, width, height);
}

/**
 * @ingroup iface_zext_screencopy_surface_v1
 *
 * Commit the screencopy surface. The frame will be copied to the surface
 * on next frame commit.
 *
 * If the "copy_on_damage" flag is set, no copies are carried out until the
 * source surface is damaged.
 */
static inline void
zext_screencopy_surface_v1_commit(struct zext_screencopy_surface_v1 *zext_screencopy_surface_v1, uint32_t options)
{
	wl_proxy_marshal((struct wl_proxy *) zext_screencopy_surface_v1,
			 ZEXT_SCREENCOPY_SURFACE_V1_COMMIT, options);
}

/**
 * @ingroup iface_zext_screencopy_surface_v1
 *
 * Destroys the surface. This request can be sent at any time by the
 * client.
 */
static inline void
zext_screencopy_surface_v1_destroy(struct zext_screencopy_surface_v1 *zext_screencopy_surface_v1)
{
	wl_proxy_marshal((struct wl_proxy *) zext_screencopy_surface_v1,
			 ZEXT_SCREENCOPY_SURFACE_V1_DESTROY);

	wl_proxy_destroy((struct wl_proxy *) zext_screencopy_surface_v1);
}

#ifdef  __cplusplus
}
#endif

#endif
